def DL(F,n):
    var('x')
    f(x) = F
    Der = f
    Pol = 0
    for k in range(n+1):
        Pol += Der(0)*x**k/factorial(k)
        Der = Der.derivative()
    return Pol

def anim_DL(f,p,xm,xM,ym,yM,d,nom):
    P = plot(f,rgbcolor='red',xmin=xm,xmax=xM,ymin=ym,ymax=yM,thickness=3,
                                                              linestyle='--')
    a = animate([[P,DL(f,k),text('n ='+str(k),(0.2*xM,0.9*yM))] for k in range(1,p)],xmin=xm,xmax=xM,ymin=ym,ymax=yM)
    a.ffmpeg(savefile ='/home/moi/IUT/INFO2/2011_12/graphes/'+nom+'.avi',delay=d)
    a.show(delay=d) # délai en 100e de seconde entre deux images.


def lagrange_plot(L):
    R = PolynomialRing(QQ, 'x')
    f = R.lagrange_polynomial(L)
    G = Graphics()
    G = plot(f(x),xmin=L[0][0]-1,xmax=L[-1][0]+1)
    for k in range(len(L)):
        G += point(L[k])
    G.show()

def lagrange_fonc(F,n,xm,xM,ym,yM):
    i = (xM-xm)/n
    var('x')
    f(x) = F
    L = [(xm + k*i,f(xm + k*i)) for k in range(n)]
    R = PolynomialRing(QQ, 'x')
    g = R.lagrange_polynomial(L)
    G = Graphics()
    G = plot(g(x),xmin=xm-1,xmax=xM+1,ymin=ym,ymax=yM)
    G += plot(f(x),xmin=xm-1,xmax=xM+1,ymin=ym,ymax=yM, rgbcolor='red' )
   # G.show()
    return G

def bezier1(P):
    G = Graphics()
    for i in range(len(P)):
        G += point(P[i],rgbcolor='green')
    var('k')
    m1(k) = map(lambda x,y : (1-0.01*k)*x + 0.01*k*y,P[0],P[1])
    m2(k) = map(lambda x,y : (1-0.01*k)*x + 0.01*k*y,P[1],P[2])
    m(k) = map(lambda x,y : (1-0.01*k)*x + 0.01*k*y,m1,m2)
    for t in range(101):
        G += point(m(t),rgbcolor='blue')
    a = animate([[G,line([m1(j),m2(j)],color='red')] for j in range(100)] )
    a.ffmpeg(savefile ='/home/moi/IUT/INFO2/2011_12/graphes/anim_bezier.avi',delay=20)
   # a.show()

#

#[xm,xM,ym,yM]=[-5,5,-0.2,1.2]

#a = animate([lagrange_fonc(1/(1+x^2),k,xm,xM,ym,yM) for k in range(1,40)],xmin=xm,xmax=xM,ymin=ym,ymax=yM)
# a.ffmpeg(savefile ='/home/moi/IUT/INFO2/2011_12/graphes/lagrange_anim.avi',delay=40)

#a.show(delay=40)
def bern(j,n,t):
    return binomial(n,j)*t**j*(1-t)**(n-j)

def bezier3(P):
    G = Graphics()
    Vi = line([P[0],P[1]],color='green')
    Vf = line([P[2],P[3]],color='green')
    G = point(P[0]) + point(P[3]) + Vi + Vf
    for k in range(1,100):
        t = 0.01*k
        M = map(lambda x,y,z,u : bern(0,3,t)*x + bern(1,3,t)*y + bern(2,3,t)*z + bern(3,3,t)*u,P[0],P[1],P[2],P[3])
        G += point(M)
    return G
    
    
def Bezier(P):
    n = len(P)
    L = []
    for k in range(n):
        if ((k % 2 == 1) and (k >= 3)) and (k < n-1):
            Q = map(lambda x,y : 2*x-y,P[k],P[k-1])
            L += [P[k],P[k],Q]
        else:
            L += [P[k]]
    N = len(L)
    G = Graphics()
    for k in range(0,N-3,4):
        G += bezier3([L[k],L[k+1],L[k+2],L[k+3]])
    G.show()


def bspline(P):
    G = Graphics()
    Vi = line([P[0],P[1]],color='green')
    Vf = line([P[2],P[3]],color='green')
    G = point(P[0]) + point(P[3]) + Vi + Vf
    for k in range(1,100):
        t = 0.01*k
        M = map(lambda x,y,z,u : ((1-t)^3*x+(3*t^3-6*t^2+4)*y+(-3*t^3+3*t^2+3*t+1)*z+t^3*u)/6,P[0],P[1],P[2],P[3])
        G += point(M)
    return G
    
def Bspline(P):
    n = len(P)
    L = []
    for k in range(n-3):
        L += [P[k],P[k+1],P[k+2],P[k+3]]
    N = len(L)
    G = Graphics()
    for k in range(0,N-3,4):
        G += bspline([L[k],L[k+1],L[k+2],L[k+3]])
    G.show()


    
#bezier1([[0,0],[3,2],[5,-2]])

bezier3([[0,0],[-1,1],[-1,0],[0,-3]])

    
Bezier([[0,2],[0,3],[0,6],[-2,6],[-4,2],[-4,0],[0,-8],[0,-8],[4,0],[4,2],[2,6],[0,6],[0,3],[0,2]])

G = Graphics()
G += bspline([[0,0],[-1,1],[-1,0],[0,-3]])+bspline([[-1,1],[-1,0],[0,-3],[0,3]])
G.show()
    
Bspline([[0,2],[0,3],[0,6],[-2,6],[-4,2],[-4,0],[0,-8],[0,-8],[4,0],[4,2],[2,6],[0,6],[0,3],[0,2]])
